diff --git a/web/pgadmin/static/js/components/PgTable.jsx b/web/pgadmin/static/js/components/PgTable.jsx
index dca323fcc..ef151b83d 100644
--- a/web/pgadmin/static/js/components/PgTable.jsx
+++ b/web/pgadmin/static/js/components/PgTable.jsx
@@ -28,6 +28,8 @@ import _ from 'lodash';
 import gettext from 'sources/gettext';
 import SchemaView from '../SchemaView';
 import EmptyPanelMessage from './EmptyPanelMessage';
+import KeyboardArrowUpIcon from '@material-ui/icons/KeyboardArrowUp';
+import KeyboardArrowDownIcon from '@material-ui/icons/KeyboardArrowDown';
 
 /* eslint-disable react/display-name */
 const useStyles = makeStyles((theme) => ({
@@ -50,31 +52,18 @@ const useStyles = makeStyles((theme) => ({
     overflowX: 'hidden !important',
     overflow: 'overlay !important',
   },
-  customHeader:{
+  CustomHeader:{
     marginTop: '8px',
     marginLeft: '4px'
   },
-  searchBox: {
-    display: 'flex',
-    background: theme.palette.background.default
-  },
   warning: {
     backgroundColor: theme.palette.warning.main + '!important'
   },
   alert: {
     backgroundColor: theme.palette.error.main + '!important'
   },
-  searchPadding: {
-    flex: 2.5
-  },
   searchInput: {
-    flex: 1,
-    marginTop: 8,
-    borderLeft: 'none',
-    paddingLeft: 5,
-    marginRight: 8,
-    marginBottom: 8,
-
+    minWidth: '300px'
   },
   tableContainer: {
     overflowX: 'auto',
@@ -93,14 +82,18 @@ const useStyles = makeStyles((theme) => ({
     flexDirection: 'column',
     height: '100%',
   },
-  pgTableHeadar: {
+  pgTableContainer: {
     display: 'flex',
     flexGrow: 1,
-    overflow: 'hidden !important',
-    height: '100% !important',
-    flexDirection: 'column'
+    overflow: 'hidden',
+    flexDirection: 'column',
+    height: '100%',
+  },
+  pgTableHeader: {
+    display: 'flex',
+    background: theme.palette.background.default,
+    padding: '8px',
   },
-
   tableRowContent:{
     display: 'flex',
     flexDirection: 'column',
@@ -138,6 +131,7 @@ const useStyles = makeStyles((theme) => ({
     overflowX: 'hidden',
     alignContent: 'center',
     backgroundColor: theme.otherVars.tableBg,
+    overflow: 'hidden',
     ...theme.mixins.panelBorder.bottom,
     ...theme.mixins.panelBorder.right,
     ...theme.mixins.panelBorder.top,
@@ -221,7 +215,7 @@ IndeterminateCheckbox.propTypes = {
 };
 
 const ROW_HEIGHT = 35;
-export default function PgTable({ columns, data, isSelectRow, caveTable=true, ...props }) {
+export default function PgTable({ columns, data, isSelectRow, caveTable=true, schema, ExpandedComponent, sortOptions, ...props }) {
   // Use the state and functions returned from useTable to build your UI
   const classes = useStyles();
   const [searchVal, setSearchVal] = React.useState('');
@@ -277,6 +271,9 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
       defaultColumn,
       isSelectRow,
       autoResetSortBy: false,
+      initialState: {
+        sortBy: sortOptions || [],
+      }
     },
     useGlobalFilter,
     useSortBy,
@@ -333,7 +330,7 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
                   />
                 </div>
               ),
-              sortble: false,
+              sortable: false,
               width: 35,
               maxWidth: 35,
               minWidth: 0
@@ -421,7 +418,7 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
                   classNames.push(classes.alert);
                 }
                 return (
-                  <div key={cell.column.id} {...cell.getCellProps()} className={clsx(classNames, row.original.icon && row.original.icon[cell.column.id], row.original.icon[cell.column.id] && classes.cellIcon)}
+                  <div key={cell.column.id} {...cell.getCellProps()} className={clsx(classNames, row.original.icon?.[cell.column.id], row.original.icon?.[cell.column.id] && classes.cellIcon)}
                     title={_.isUndefined(cell.value) || _.isNull(cell.value) ? '': String(cell.value)}>
                     {cell.render('Cell')}
                   </div>
@@ -430,13 +427,14 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
             </div>
             {!_.isUndefined(row) && row.isExpanded && (
               <Box key={row.id} className={classes.expandedForm}>
-                <SchemaView
+                {schema && <SchemaView
                   getInitData={()=>Promise.resolve({})}
                   viewHelperProps={{ mode: 'properties' }}
-                  schema={props.schema[row.id]}
+                  schema={schema[row.id]}
                   showFooter={false}
                   onDataChange={()=>{setExpandComplete(true);}}
-                />
+                />}
+                {ExpandedComponent && <ExpandedComponent row={row} onExpandComplete={()=>setExpandComplete(true)}/>}
               </Box>
             )}
           </div>
@@ -447,24 +445,30 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
   );
   // Render the UI for your table
   return (
-    <Box className={classes.pgTableHeadar}>
-      <Box className={classes.searchBox}>
-        {props.customHeader && (<Box className={classes.customHeader}> <props.customHeader /></Box>)}
-        <Box className={classes.searchPadding}></Box>
-        <InputText
-          placeholder={'Search'}
-          className={classes.searchInput}
-          value={searchVal}
-          onChange={(val) => {
-            setSearchVal(val);
-          }}
-        />
+    <Box className={classes.pgTableContainer}>
+      <Box className={classes.pgTableHeader}>
+        {props.CustomHeader && (<Box className={classes.customHeader}> <props.CustomHeader /></Box>)}
+        <Box marginLeft="auto">
+          <InputText
+            placeholder={'Search'}
+            className={classes.searchInput}
+            value={searchVal}
+            onChange={(val) => {
+              setSearchVal(val);
+            }}
+          />
+        </Box>
       </Box>
       <div className={classes.tableContainer}>
         <div {...getTableProps({style:{minWidth: totalColumnsWidth}})} className={clsx(classes.table, caveTable ? classes.caveTable : '')}>
           <div>
             {headerGroups.map((headerGroup) => (
-              <div key={''} {...headerGroup.getHeaderGroupProps()}>
+              <div key={''} {...headerGroup.getHeaderGroupProps((column)=>({
+                style: {
+                  ...column.style,
+                  height: '40px',
+                }
+              }))}>
                 {headerGroup.headers.map((column) => (
                   <div
                     key={column.id}
@@ -472,14 +476,14 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
                     className={clsx(classes.tableCellHeader, column.className)}
                   >
                     <div
-                      {...(column.sortble ? column.getSortByToggleProps() : {})}
+                      {...(column.sortable ? column.getSortByToggleProps() : {})}
                     >
                       {column.render('Header')}
                       <span>
                         {column.isSorted
                           ? column.isSortedDesc
-                            ? ' 🔽'
-                            : ' 🔼'
+                            ? <KeyboardArrowDownIcon style={{fontSize: '1.2rem'}} />
+                            : <KeyboardArrowUpIcon style={{fontSize: '1.2rem'}} />
                           : ''}
                       </span>
                     </div>
@@ -507,14 +511,13 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
                       height={height}
                       itemCount={rows.length}
                       itemSize={getRowHeight}
-                      sorted={props?.sortOptions}
                     >
                       {RenderRow}
                     </VariableSizeList>)}
                 </AutoSizer>
               </div>
             ) : (
-              <EmptyPanelMessage text={gettext('No record found')}/>
+              <EmptyPanelMessage text={gettext('No rows found')}/>
             )
           }
         </div>
@@ -526,7 +529,7 @@ export default function PgTable({ columns, data, isSelectRow, caveTable=true, ..
 PgTable.propTypes = {
   stepId: PropTypes.number,
   height: PropTypes.number,
-  customHeader: PropTypes.func,
+  CustomHeader: PropTypes.func,
   className: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
   caveTable: PropTypes.bool,
   fixedSizeList: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
@@ -544,8 +547,8 @@ PgTable.propTypes = {
   setSelectedRows: PropTypes.func,
   getSelectedRows: PropTypes.func,
   searchText: PropTypes.string,
-  type: PropTypes.string,
   sortOptions: PropTypes.array,
   schema: PropTypes.object,
-  rows: PropTypes.object
+  rows: PropTypes.object,
+  ExpandedComponent: PropTypes.node,
 };
diff --git a/web/pgadmin/static/js/custom_hooks.js b/web/pgadmin/static/js/custom_hooks.js
index a38088851..b77df8d70 100644
--- a/web/pgadmin/static/js/custom_hooks.js
+++ b/web/pgadmin/static/js/custom_hooks.js
@@ -13,6 +13,7 @@ export function useInterval(callback, delay) {
     }
 
     if(delay > -1) {
+      tick();
       let id = setInterval(tick, delay);
       return () => clearInterval(id);
     }
diff --git a/web/pgadmin/static/js/helpers/Notifier.jsx b/web/pgadmin/static/js/helpers/Notifier.jsx
index 95d837e8e..702c780ec 100644
--- a/web/pgadmin/static/js/helpers/Notifier.jsx
+++ b/web/pgadmin/static/js/helpers/Notifier.jsx
@@ -92,7 +92,7 @@ const useModalStyles = makeStyles((theme)=>({
   },
   margin: {
     marginLeft: '0.25rem',
-  }
+  },
 }));
 function AlertContent({text, confirm, okLabel=gettext('OK'), cancelLabel=gettext('Cancel'), onOkClick, onCancelClick}) {
   const classes = useModalStyles();
@@ -144,11 +144,10 @@ var Notifier = {
     }
   },
   _callNotify(msg, type, autoHideDuration) {
-    if (!_.isNull(autoHideDuration)) {
-      this.notify(<NotifierMessage type={type} message={msg} closable={false} />, autoHideDuration);
-    } else {
-      this.notify(<NotifierMessage type={type} message={msg}/>, null);
-    }
+    this.notify(
+      <NotifierMessage style={{maxWidth: '50vw'}} type={type} message={msg} closable={_.isNull(autoHideDuration) ? true : false} />,
+      autoHideDuration
+    );
   },
 
   pgRespErrorNotify(xhr, error, prefixMsg='') {
diff --git a/web/pgadmin/tools/backup/__init__.py b/web/pgadmin/tools/backup/__init__.py
index 0742e5882..afc6f00f8 100644
--- a/web/pgadmin/tools/backup/__init__.py
+++ b/web/pgadmin/tools/backup/__init__.py
@@ -6,7 +6,6 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-
 """Implements Backup Utility"""
 
 import simplejson as json
@@ -161,8 +160,7 @@ class BackupMessage(IProcessDesc):
     def details(self, cmd, args):
         name, host, port = self.get_server_details()
 
-        res = '<div>'
-
+        msg = "Backup"
         if self.backup_type == BACKUP.OBJECT:
             msg = _(
                 "Backing up an object on the server '{0}' "
@@ -173,7 +171,6 @@ class BackupMessage(IProcessDesc):
                 ),
                 self.database
             )
-            res += html.safe_str(msg)
         elif self.backup_type == BACKUP.GLOBALS:
             msg = _("Backing up the global objects on "
                     "the server '{0}'...").format(
@@ -181,25 +178,17 @@ class BackupMessage(IProcessDesc):
                     name, host, port
                 )
             )
-            res += html.safe_str(msg)
         elif self.backup_type == BACKUP.SERVER:
             msg = _("Backing up the server '{0}'...").format(
                 self.args_str.format(
                     name, host, port
                 )
             )
-            res += html.safe_str(msg)
-        else:
-            # It should never reach here.
-            res += "Backup"
-
-        res += '</div><div class="py-1">'
-        res += _("Running command:")
-        res += '<div class="pg-bg-cmd enable-selection p-1">'
-        res += html.safe_str(cmd + self.cmd)
-        res += '</div></div>'
 
-        return res
+        return {
+            "message": msg,
+            "cmd": cmd + self.cmd
+        }
 
 
 @blueprint.route("/")
@@ -487,7 +476,7 @@ def create_backup_objects_job(sid):
 
     # Return response
     return make_json_response(
-        data={'job_id': jid, 'Success': 1}
+        data={'job_id': jid, 'desc': p.desc.message, 'Success': 1}
     )
 
 
diff --git a/web/pgadmin/tools/backup/static/js/backup.js b/web/pgadmin/tools/backup/static/js/backup.js
index afe0c50a9..ca2642fbe 100644
--- a/web/pgadmin/tools/backup/static/js/backup.js
+++ b/web/pgadmin/tools/backup/static/js/backup.js
@@ -181,7 +181,7 @@ define([
           gettext(data.errormsg)
         );
       } else {
-        pgBrowser.Events.trigger('pgadmin-bgprocess:created');
+        pgBrowser.BgProcessManager.startProcess(data.data.job_id, data.data.desc);
       }
     },
     url_for_utility_exists(id, params){
diff --git a/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx b/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx
index 2706432be..9fedec760 100644
--- a/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx
+++ b/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx
@@ -65,21 +65,21 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData, onClose }) {
 
       Header: 'Object Type',
       accessor: 'object_type',
-      sortble: true,
+      sortable: true,
       resizable: false,
       disableGlobalFilter: true
     },
     {
       Header: 'Schema',
       accessor: 'nspname',
-      sortble: true,
+      sortable: true,
       resizable: false,
       disableGlobalFilter: true
     },
     {
       Header: 'Name',
       accessor: 'name_with_args',
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 280
@@ -87,7 +87,7 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData, onClose }) {
     {
       Header: 'parameters',
       accessor: 'proargs',
-      sortble: false,
+      sortable: false,
       resizable: false,
       disableGlobalFilter: false,
       minWidth: 280,
@@ -96,7 +96,7 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData, onClose }) {
     {
       Header: 'Name',
       accessor: 'name',
-      sortble: false,
+      sortable: false,
       resizable: false,
       disableGlobalFilter: false,
       minWidth: 280,
@@ -105,7 +105,7 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData, onClose }) {
     {
       Header: 'ID',
       accessor: 'oid',
-      sortble: false,
+      sortable: false,
       resizable: false,
       disableGlobalFilter: false,
       minWidth: 280,
diff --git a/web/pgadmin/tools/import_export/__init__.py b/web/pgadmin/tools/import_export/__init__.py
index f30229da9..1555b9779 100644
--- a/web/pgadmin/tools/import_export/__init__.py
+++ b/web/pgadmin/tools/import_export/__init__.py
@@ -123,28 +123,20 @@ class IEMessage(IProcessDesc):
         # Fetch the server details like hostname, port, roles etc
         name, host, port = self.get_server_details()
 
-        res = '<div>'
-        res += _(
+        msg = _(
             "Copying table data '{0}.{1}' on database '{2}' "
             "for the server '{3}'"
         ).format(
-            html.safe_str(self.schema),
-            html.safe_str(self.table),
-            html.safe_str(self.database),
-            "{0} ({1}:{2})".format(
-                html.safe_str(name),
-                html.safe_str(host),
-                html.safe_str(port)
-            )
+            self.schema,
+            self.table,
+            self.database,
+            "{0} ({1}:{2})".format(name, host, port)
         )
 
-        res += '</div><div class="py-1">'
-        res += _("Running command:")
-        res += '<div class="pg-bg-cmd enable-selection p-1">'
-        res += html.safe_str(self._cmd)
-        res += '</div></div>'
-
-        return res
+        return {
+            "message": msg,
+            "cmd": self._cmd
+        }
 
 
 @blueprint.route("/")
@@ -387,7 +379,7 @@ def create_import_export_job(sid):
 
     # Return response
     return make_json_response(
-        data={'job_id': jid, 'success': 1}
+        data={'job_id': jid, 'desc': p.desc.message, 'success': 1}
     )
 
 
diff --git a/web/pgadmin/tools/import_export/static/js/import_export.js b/web/pgadmin/tools/import_export/static/js/import_export.js
index 4cfebf480..14b787062 100644
--- a/web/pgadmin/tools/import_export/static/js/import_export.js
+++ b/web/pgadmin/tools/import_export/static/js/import_export.js
@@ -83,7 +83,7 @@ define([
         );
       } else {
         Notify.success(gettext('Import/Export job created.'));
-        pgBrowser.Events.trigger('pgadmin-bgprocess:created');
+        pgBrowser.BgProcessManager.startProcess(data.data.job_id, data.data.desc);
       }
     },
 
diff --git a/web/pgadmin/tools/maintenance/__init__.py b/web/pgadmin/tools/maintenance/__init__.py
index f84da2587..53ca712c0 100644
--- a/web/pgadmin/tools/maintenance/__init__.py
+++ b/web/pgadmin/tools/maintenance/__init__.py
@@ -129,15 +129,10 @@ class Message(IProcessDesc):
         return res
 
     def details(self, cmd, args):
-
-        res = '<div>' + self.message
-        res += '</div><div class="py-1">'
-        res += _("Running Query:")
-        res += '<div class="pg-bg-cmd enable-selection p-1">'
-        res += html.safe_str(self.query)
-        res += '</div></div>'
-
-        return res
+        return {
+            "message": self.message,
+            "query": self.query
+        }
 
 
 @blueprint.route("/")
@@ -272,7 +267,7 @@ def create_maintenance_job(sid, did):
 
     # Return response
     return make_json_response(
-        data={'job_id': jid, 'status': True,
+        data={'job_id': jid, 'desc': p.desc.message, 'status': True,
               'info': _('Maintenance job created.')}
     )
 
diff --git a/web/pgadmin/tools/maintenance/static/js/maintenance.js b/web/pgadmin/tools/maintenance/static/js/maintenance.js
index cbf9388e0..46a058196 100644
--- a/web/pgadmin/tools/maintenance/static/js/maintenance.js
+++ b/web/pgadmin/tools/maintenance/static/js/maintenance.js
@@ -93,7 +93,7 @@ define([
         );
       } else {
         Notify.success(data.data.info);
-        pgBrowser.Events.trigger('pgadmin-bgprocess:created');
+        pgBrowser.BgProcessManager.startProcess(data.data.job_id, data.data.desc);
       }
     },
     setExtraParameters(treeInfo) {
diff --git a/web/pgadmin/tools/restore/__init__.py b/web/pgadmin/tools/restore/__init__.py
index 76f4d9df3..dec38c7b8 100644
--- a/web/pgadmin/tools/restore/__init__.py
+++ b/web/pgadmin/tools/restore/__init__.py
@@ -107,22 +107,15 @@ class RestoreMessage(IProcessDesc):
 
     def details(self, cmd, args):
         name, host, port = self.get_server_details()
-        res = '<div>'
-
-        res += html.safe_str(
-            _(
-                "Restoring backup on the server '{0}'..."
-            ).format(
-                "{0} ({1}:{2})".format(name, host, port)
-            )
+        msg = _(
+            "Restoring backup on the server '{0}'..."
+        ).format(
+            "{0} ({1}:{2})".format(name, host, port)
         )
-
-        res += '</div><div class="py-1">'
-        res += _("Running command:")
-        res += '<div class="pg-bg-cmd enable-selection p-1">'
-        res += html.safe_str(cmd + self.cmd)
-        res += '</div></div>'
-        return res
+        return {
+            "message": msg,
+            "cmd": cmd + self.cmd
+        }
 
 
 @blueprint.route("/")
@@ -434,7 +427,7 @@ def create_restore_job(sid):
         )
     # Return response
     return make_json_response(
-        data={'job_id': jid, 'Success': 1}
+        data={'job_id': jid, 'desc': p.desc.message, 'Success': 1}
     )
 
 
diff --git a/web/pgadmin/tools/restore/static/js/restore.js b/web/pgadmin/tools/restore/static/js/restore.js
index 3ad192cf5..0f33ef334 100644
--- a/web/pgadmin/tools/restore/static/js/restore.js
+++ b/web/pgadmin/tools/restore/static/js/restore.js
@@ -97,7 +97,7 @@ define('tools.restore', [
           gettext(data.errormsg)
         );
       } else {
-        pgBrowser.Events.trigger('pgadmin-bgprocess:created');
+        pgBrowser.BgProcessManager.startProcess(data.data.job_id, data.data.desc);
       }
     },
     setExtraParameters: function(treeInfo, nodeData) {
diff --git a/web/regression/javascript/fake_endpoints.js b/web/regression/javascript/fake_endpoints.js
index 79686fe55..b06219974 100644
--- a/web/regression/javascript/fake_endpoints.js
+++ b/web/regression/javascript/fake_endpoints.js
@@ -36,5 +36,9 @@ define(function () {
     'file_manager.save_file_dialog_view': '/file_manager/save_file_dialog_view/<int:trans_id>',
     'file_manager.save_show_hidden_file_option': '/file_manager/save_show_hidden_file_option/<int:trans_id>',
     'settings.save_file_format_setting': '/settings/save_file_format_setting/',
+    'bgprocess.detailed_status': '/misc/bgprocess/<pid>/<int:out>/<int:err>/',
+    'bgprocess.list': '/misc/bgprocess/',
+    'bgprocess.stop_process': '/misc/bgprocess/stop/<pid>',
+    'bgprocess.acknowledge': '/misc/bgprocess/<pid>'
   };
 });
diff --git a/web/regression/javascript/processes/BgProcessManager.spec.js b/web/regression/javascript/processes/BgProcessManager.spec.js
new file mode 100644
index 000000000..573f88129
--- /dev/null
+++ b/web/regression/javascript/processes/BgProcessManager.spec.js
@@ -0,0 +1,120 @@
+import MockAdapter from 'axios-mock-adapter';
+import axios from 'axios/index';
+import BgProcessManager, { BgProcessManagerProcessState } from '../../../pgadmin/misc/bgprocess/static/js/BgProcessManager';
+import * as BgProcessNotify from '../../../pgadmin/misc/bgprocess/static/js/BgProcessNotify';
+
+
+
+describe('BgProcessManager', ()=>{
+  let obj;
+  let networkMock;
+  const pgBrowser = jasmine.createSpyObj('pgBrowser', [], {
+    docker: {
+      findPanels: ()=>{/* dummy */},
+      addPanel: ()=>{/* dummy */}
+    }
+  });
+
+  beforeAll(()=>{
+    networkMock = new MockAdapter(axios);
+    networkMock.onGet('/misc/bgprocess/').reply(200, [{}]);
+    networkMock.onPut('/misc/bgprocess/stop/12345').reply(200,{});
+    networkMock.onPut('/misc/bgprocess/12345').reply(200,{});
+  });
+
+  afterAll(() => {
+    networkMock.restore();
+  });
+
+  beforeEach(()=>{
+    obj = new BgProcessManager(pgBrowser);
+  });
+
+  it('init', ()=>{
+    spyOn(obj, 'startWorker');
+    obj.init();
+    expect(obj.startWorker).toHaveBeenCalled();
+  });
+
+  it('procList', ()=>{
+    obj._procList = [{a: '1'}];
+    expect(obj.procList).toEqual([{a: '1'}]);
+  });
+
+  it('startWorker', (done)=>{
+    spyOn(obj, 'syncProcesses');
+    obj._pendingJobId = ['123123123123'];
+    obj.startWorker();
+
+    setTimeout(()=>{
+      expect(obj.syncProcesses).toHaveBeenCalled();
+      done();
+    }, 2000);
+  });
+
+  it('startProcess', ()=>{
+    let nSpy = spyOn(BgProcessNotify, 'processStarted');
+    obj.startProcess('12345', 'process desc');
+    expect(obj._pendingJobId).toEqual(['12345']);
+    expect(nSpy.calls.mostRecent().args[0]).toBe('process desc');
+  });
+
+
+  it('stopProcess', (done)=>{
+    obj._procList = [{
+      id: '12345',
+      process_state: BgProcessManagerProcessState.PROCESS_STARTED,
+    }];
+
+    obj.stopProcess('12345');
+    setTimeout(()=>{
+      expect(obj._procList[0].process_state).toBe(BgProcessManagerProcessState.PROCESS_TERMINATED);
+      done();
+    }, 500);
+  });
+
+  it('acknowledge', (done)=>{
+    obj._procList = [{
+      id: '12345',
+      process_state: BgProcessManagerProcessState.PROCESS_FINISHED,
+    }];
+
+    obj.acknowledge('12345');
+    setTimeout(()=>{
+      expect(obj._procList.length).toBe(0);
+      done();
+    }, 500);
+  });
+
+
+  it('checkPending', ()=>{
+    obj._procList = [{
+      id: '12345',
+      process_state: BgProcessManagerProcessState.PROCESS_FINISHED,
+    }];
+    obj._pendingJobId = ['12345'];
+    let nSpy = spyOn(BgProcessNotify, 'processCompleted');
+    obj.checkPending();
+    expect(nSpy).toHaveBeenCalled();
+  });
+
+
+  it('openProcessesPanel', ()=>{
+    const panel = {
+      focus: ()=>{/* dummy */}
+    };
+    spyOn(pgBrowser.docker, 'addPanel').and.returnValue(panel);
+
+    /* panel open */
+    spyOn(pgBrowser.docker, 'findPanels').and.returnValue([panel]);
+    obj.openProcessesPanel();
+    expect(pgBrowser.docker.addPanel).not.toHaveBeenCalled();
+
+    /* panel closed */
+    spyOn(pgBrowser.docker, 'findPanels')
+      .withArgs('processes').and.returnValue([])
+      .withArgs('properties').and.returnValue([panel]);
+    obj.openProcessesPanel();
+    expect(pgBrowser.docker.addPanel).toHaveBeenCalled();
+  });
+});
diff --git a/web/regression/javascript/processes/BgProcessNotify.spec.js b/web/regression/javascript/processes/BgProcessNotify.spec.js
new file mode 100644
index 000000000..454d8ba2c
--- /dev/null
+++ b/web/regression/javascript/processes/BgProcessNotify.spec.js
@@ -0,0 +1,75 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import BgProcessManager, { BgProcessManagerProcessState } from '../../../pgadmin/misc/bgprocess/static/js/BgProcessManager';
+import pgAdmin from 'sources/pgadmin';
+import * as BgProcessNotify from '../../../pgadmin/misc/bgprocess/static/js/BgProcessNotify';
+import Notifier from '../../../pgadmin/static/js/helpers/Notifier';
+
+describe('BgProcessNotify', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+    pgAdmin.Browser = pgAdmin.Browser || {};
+    pgAdmin.Browser.BgProcessManager = new BgProcessManager(pgAdmin.Browser);
+  });
+
+  it('processStarted', ()=>{
+    const nspy = spyOn(Notifier, 'notify');
+    BgProcessNotify.processStarted('some desc', ()=>{/* dummy */});
+    expect(nspy.calls.mostRecent().args[0].props).toEqual(jasmine.objectContaining({
+      title: 'Process started',
+      desc: 'some desc',
+    }));
+  });
+
+  it('processCompleted success', ()=>{
+    const nspy = spyOn(Notifier, 'notify');
+    BgProcessNotify.processCompleted('some desc', BgProcessManagerProcessState.PROCESS_FINISHED, ()=>{/* dummy */});
+    expect(nspy.calls.mostRecent().args[0].props).toEqual(jasmine.objectContaining({
+      title: 'Process completed',
+      desc: 'some desc',
+      success: true,
+    }));
+  });
+
+  it('processCompleted failed', ()=>{
+    const nspy = spyOn(Notifier, 'notify');
+    BgProcessNotify.processCompleted('some desc', BgProcessManagerProcessState.PROCESS_FAILED, ()=>{/* dummy */});
+    expect(nspy.calls.mostRecent().args[0].props).toEqual(jasmine.objectContaining({
+      title: 'Process failed',
+      desc: 'some desc',
+      success: false,
+    }));
+  });
+
+  it('processCompleted terminated', ()=>{
+    const nspy = spyOn(Notifier, 'notify');
+    BgProcessNotify.processCompleted('some desc', BgProcessManagerProcessState.PROCESS_TERMINATED, ()=>{/* dummy */});
+    expect(nspy.calls.mostRecent().args[0].props).toEqual(jasmine.objectContaining({
+      title: 'Process terminated',
+      desc: 'some desc',
+      success: false,
+    }));
+  });
+});
diff --git a/web/regression/javascript/processes/Proceses.spec.js b/web/regression/javascript/processes/Proceses.spec.js
new file mode 100644
index 000000000..0de21f8ca
--- /dev/null
+++ b/web/regression/javascript/processes/Proceses.spec.js
@@ -0,0 +1,76 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import Theme from '../../../pgadmin/static/js/Theme';
+import BgProcessManager, { BgProcessManagerProcessState } from '../../../pgadmin/misc/bgprocess/static/js/BgProcessManager';
+import pgAdmin from 'sources/pgadmin';
+import Processes from '../../../pgadmin/misc/bgprocess/static/js/Processes';
+
+
+const processData = {
+  acknowledge: null,
+  current_storage_dir: null,
+  desc: 'Doing some operation on the server \'PostgreSQL 12 (localhost:5432)\'',
+  details: {
+    cmd: '/Library/PostgreSQL/12/bin/mybin --testing',
+    message: 'Doing some detailed operation on the server \'PostgreSQL 12 (localhost:5432)\'...'
+  },
+  etime: null,
+  execution_time: 0.09,
+  exit_code: null,
+  id: '220803091429498400',
+  process_state: BgProcessManagerProcessState.PROCESS_STARTED,
+  stime: '2022-08-03T09:14:30.191940+00:00',
+  type_desc: 'Operation on the server',
+  utility_pid: 140391
+};
+
+describe('Proceses', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+    pgAdmin.Browser = pgAdmin.Browser || {};
+    pgAdmin.Browser.BgProcessManager = new BgProcessManager(pgAdmin.Browser);
+    pgAdmin.Browser.BgProcessManager._procList = [processData];
+  });
+
+  describe('ProcessDetails', ()=>{
+    let ctrlMount = (props)=>{
+      return mount(<Theme>
+        <Processes
+          {...props}
+        />
+      </Theme>);
+    };
+
+    it('init', (done)=>{
+      let ctrl = ctrlMount({});
+      setTimeout(()=>{
+        ctrl.update();
+        expect(ctrl.find('PgTable').length).toBe(1);
+        done();
+      }, 1000);
+    });
+  });
+});
